/*
 * This file is released into the public domain by Zwagoth. No copyright claimed.
 * Super lazy and sloppy patcher for removing chromatic abberation from PAYDAY 2.
 */


#define WIN32_LEAN_AND_MEAN
#include <Windows.h>
#include <CommCtrl.h>
#include <CommDlg.h>
#include <Shlwapi.h>
#include "resource.h"

extern "C" {
void __stdcall SearchAndReplace(void* _targetadress ,const char* _searchpattern, const char* _searchmask, const char* _replacepattern,
	const char* _replacemask, DWORD _patternsize, DWORD _searchsize, DWORD _patchnumber);
};

const char* pt1 = "<variable name=\"chromatic_amount\" type=\"scalar\" value=\"0.2\"/>";
const char pt1mask[61] = {0};
const char* pt1replace = "<variable name=\"chromatic_amount\" type=\"scalar\" value=\"0.0\"/>";

const char* pt2 = "<combiner diffuse_texture=\"bb\" dst=\"bb\" render_template=\"post_chromatic_aberration\" material=\"post_DOF\" scriptable=\"post_DOF\"/>";
const char pt2mask[127] = {0};
const char* pt2replace = "                                                                                                                               ";

char path[1024] = {0};
char backup_path[1024] = {0};
const char* filterString = "3b6c2da5af6f2e42.bundle\0*3b6c2da5af6f2e42.bundle\0";

void PatchFile(HWND hWnd)
{
	OPENFILENAME openstruct;
	SecureZeroMemory(&openstruct, sizeof(openstruct));
	openstruct.lStructSize = sizeof(openstruct);
	openstruct.lpstrFilter = filterString;
	openstruct.lpstrFile = path;
	openstruct.nMaxFile = sizeof(path);
	openstruct.hwndOwner = hWnd;
	openstruct.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
	if( GetOpenFileName(&openstruct) )
	{
		PathCombine(backup_path, path, "");
		PathRemoveExtension(backup_path);
		PathAddExtension(backup_path, ".bundle.BAK");
		CopyFile(path, backup_path, FALSE);
		HANDLE file = CreateFile(path, GENERIC_READ+GENERIC_WRITE, FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL+FILE_ATTRIBUTE_HIDDEN, 0);
		if(file == INVALID_HANDLE_VALUE)
		{
			SetDlgItemText(hWnd, IDC_EDIT1, "Could not open file for patching.");
			return;
		}
		HANDLE mapping = CreateFileMapping(file, 0, PAGE_READWRITE, 0, 0, 0);
		if(!mapping)
		{
			SetDlgItemText(hWnd, IDC_EDIT1, "Could not create file mapping.");
			CloseHandle(file);
			return;
		}
		DWORD size_of_file = GetFileSize(file, 0);
		void* file_buffer = MapViewOfFile(mapping, FILE_MAP_WRITE, 0, 0, 0);
		if(!file_buffer)
		{
			SetDlgItemText(hWnd, IDC_EDIT1, "Could not map view of file. File may be in use.");
			CloseHandle(mapping);
			CloseHandle(file);
			return;
		}
		SearchAndReplace(file_buffer, pt1, pt1mask, pt1replace, pt1mask, 61, size_of_file, 1);
		SearchAndReplace(file_buffer, pt2, pt2mask, pt2replace, pt2mask, 127, size_of_file, 1);
		UnmapViewOfFile(file_buffer);
		CloseHandle(mapping);
		CloseHandle(file);
		SetDlgItemText(hWnd, IDC_EDIT1, "File successfully patched. You may now close the patcher.");
	}
	return;
}

INT_PTR __stdcall dlgProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		SetDlgItemText(hWnd, IDC_EDIT1, "Chromatic Abberation Remover By Zwagoth Ready. Click Patch.");
		break;
	case WM_COMMAND:
		if ( (wParam & 0xFF) == IDOK)
		{
			PatchFile(hWnd);
		}
		break;
	case WM_CLOSE:
		EndDialog(hWnd, 0);
		break;
	default:
		break;
	}
	return 0;
}


void __stdcall StartFunction()
{
	InitCommonControls();
	DialogBoxParam(GetModuleHandle(NULL), (LPCSTR)IDD_DIALOG1, 0, dlgProc, 0);
	ExitProcess(0);
}